/* KApplicationDel */

#import <Cocoa/Cocoa.h>

#define KFontFamilyMenuItemName @"Font Family & Style"
#define KFontSizeMenuItemName @"Font Size"
#define KTabWidthMenuitemName @"Tab Width"
#define KTagMenuItemName @"HTML Tags"
#define KURLMenuItemName @"URLs"
#define KScriptsMenuItemName @"Tools"


#define KFontFamilyArray @"font_family_array"
#define KFontSizeArray @"font_size_array"
#define KTagArray @"tag_array"
#define KURLArray @"url_array"


@interface KApplicationDel : NSObject
{
	IBOutlet id myGotoLineWindow;
	IBOutlet id myGotoLineTextField;

	id mSearchServer;
	id mPrefsServer;	
	
	NSMutableDictionary* mMenuDict;
	
}

// Interface for outer objects.
- (void)showGotoLineWindow;
- (void)hideGotoLineWindow;

// NSApplication delegate methods.
- (void)applicationDidFinishLaunching:(NSNotification*)notification;

// construct menus.
- (void)constructMenus;

// accessing servers.
- (id)searchServer;
- (id)prefsServer;

- (NSArray*)menuDict:(NSString*)name;

// internal use.
- (void)addFontFamilyMenu;
- (void)addFontSizeMenu;
- (void)addTagMenu;
- (void)addURLMenu;
- (void)addScriptsMenu;
- (void)dealloc;

@end

@interface NSApplication (ScriptSupport)

// scripting.

- (void)handleCreateCommand:(NSScriptCommand*)command;

@end



