#import "KApplicationDel.h"
#import "MyDocument.h"
#import "KSearchServer.h"
#import "KPrefsServer.h"
#import "KMenuUtils.h"

@implementation KApplicationDel

- (id)init
{
	[super init];
	
	mPrefsServer = [[KPrefsServer alloc] init];
	mSearchServer = nil;
	
	mMenuDict = [[NSMutableDictionary alloc] initWithCapacity:10];
	
	return self;
}

// MainMenu loaded.
- (void)awakeFromNib
{
	[self constructMenus];
}

- (void)constructMenus
{
	[self addFontFamilyMenu];
	[self addFontSizeMenu];
	[self addTagMenu];
	[self addURLMenu];
	[self addScriptsMenu];//currently Tools menu.
}


- (void)showGotoLineWindow
{
	[myGotoLineWindow makeKeyAndOrderFront:self];
	[myGotoLineWindow makeKeyAndOrderFront:self];
	// why twice? I think so. but, this is the most simple way to let a panel be key.
}

- (void)hideGotoLineWindow
{
	[myGotoLineWindow orderOut:self];
	[myGotoLineTextField setStringValue:@""];
}

- (void)applicationDidFinishLaunching:(NSNotification*)notification
{
	//NSFileManager* manager = [NSFileManager defaultManager];
	//[manager createFileAtPath:@"/Users/karino/index.html" contents:[NSData data] attributes:nil];
	// do nothing.
}

- (void)addFontFamilyMenu
{
	NSMenu* mainMenu = [NSApp mainMenu];
	NSMenuItem* menuItem = [KMenuUtils searchMenuItemOfMenu:mainMenu localizedString:KFontFamilyMenuItemName];
	NSArray* array;
	array = [KMenuUtils attachFontMenuToMenuItem:menuItem selector:@selector(setFontFamily:)];
	[mMenuDict setObject:array forKey:KFontFamilyArray];
}

- (void)addFontSizeMenu
{
	NSMenu* mainMenu = [NSApp mainMenu];
	NSMenuItem* menuItem = [KMenuUtils searchMenuItemOfMenu:mainMenu localizedString:KFontSizeMenuItemName];
	NSArray* array;
	array = [KMenuUtils attachSizeMenuToMenuItem:menuItem selector:@selector(setFontSize:)];
	[mMenuDict setObject:array forKey:KFontSizeArray];
}

- (void)addTagMenu
{
	NSMenu* mainMenu = [NSApp mainMenu];
	NSMenuItem* menuItem = [KMenuUtils searchMenuItemOfMenu:mainMenu localizedString:KTagMenuItemName];
	[KMenuUtils attachTagMenuToMenuItem:menuItem selector:@selector(insertMenuTag:)];
}

- (void)addURLMenu
{
	NSMenu* mainMenu = [NSApp mainMenu];
	NSMenuItem* menuItem = [KMenuUtils searchMenuItemOfMenu:mainMenu localizedString:KURLMenuItemName];
	[KMenuUtils attachURLMenuToMenuItem:menuItem selector:@selector(insertMenuURL:)];
}

- (void)addScriptsMenu
{
	NSMenu* mainMenu = [NSApp mainMenu];
	NSMenuItem* menuItem = [KMenuUtils searchMenuItemOfMenu:mainMenu localizedString:KScriptsMenuItemName];
	NSMenu* menu = [[NSMenu alloc] initWithTitle:KScriptsMenuItemName];
	[menuItem setSubmenu:menu];
	[KMenuUtils attachScriptsMenuToMenu:menu selector:@selector(executeScript:)];
}



- (KSearchServer*)searchServer
{
	if(mSearchServer == nil){
		mSearchServer = [[KSearchServer alloc] init];
	}
	return mSearchServer;
}
- (KPrefsServer*)prefsServer
{
	return mPrefsServer;
}

- (NSArray*)menuDict:(NSString*)name
{
	return [mMenuDict objectForKey:name];
}

- (void)dealloc
{
	NSLog(@"KApplicationDel : dealloc");
	[mSearchServer release];
	[mPrefsServer release];
	
	[mMenuDict release];
	
	[super dealloc];
}

@end

@implementation NSApplication (ScriptSupport)

- (void)handleCreateCommand:(NSScriptCommand*)command
{
	[[NSDocumentController sharedDocumentController] newDocument:nil];
}


@end


