/* KSearchServer */

#import <Cocoa/Cocoa.h>

typedef enum { KSearchForward, KSearchBackward } KSearchDirection;


@interface KSearchServer : NSObject
{
	IBOutlet id mySearchWindow;
	
	IBOutlet id mySearchField;
	IBOutlet id myReplaceField;
	
	IBOutlet id myIgnoreCaseCheckBox;
	IBOutlet id myUseRegexCheckBox;
	
	id mSearchCaller;
	
	
	NSString* mSearchString;
	NSString* mReplaceString;
	
	BOOL mIgnoreCase;
	BOOL mUseRegex;
}

// for the use of other classes.
- (void)showSearchWindow:(id)sender;
- (NSRange)searchString:(NSTextView*)textView direction:(KSearchDirection)direction;
- (unsigned)replaceAll:(NSTextView*)textView;

// Actions called when one of buttons will be pressed.
- (IBAction)searchButtonPressed:(id)sender;
- (IBAction)replaceAllButtonPressed:(id)sender;
- (IBAction)cancelButtonPressed:(id)sender;
- (IBAction)setButtonPressed:(id)sender;

- (IBAction)ignoreCaseButtonPressed:(id)sender;
- (IBAction)useRegexButtonPressed:(id)sender;


// treat data-members.


- (void)setSearchString:(NSString*)searchString;
- (NSString*)searchString;
- (void)setReplaceString:(NSString*)replaceString;
- (NSString*)replaceString;

- (void)setIgnoreCase:(BOOL)ignoreCase;
- (BOOL)ignoreCase;
- (void)setUseRegex:(BOOL)useRegex;
- (BOOL)useRegex;

@end
